local team = { {}, {} }
local lookup = { {}, {} }
local summon = { }

local NEXT_PET_CHECK = 0

local function insertInTeam(team, lookup, unit)
	local guid = UnitGUID(unit)
	if guid and not lookup[guid] then
		local name = UnitName(unit)
		local index = #team + 1

		lookup[guid] = index
		team[index] = guid.."/"..name
		PABR_SetDirty()
	end
end

local function clearFromTeam(team, lookup, unit)
	local guid = UnitGUID(unit)
	if guid and lookup[guid] then
		-- TODO: remove from team table and shift the remainder
		team[lookup[guid]] = "-/-" -- TODO: remove this
		lookup[guid] = nil
		PABR_SetDirty()
	end
end

local function insertPet(petUnit, masterUnit)
	local petGUID = UnitGUID(petUnit)
	local masterGUID = UnitGUID(masterUnit)
	if petGUID and masterGUID then
		summon[petGUID] = masterGUID
	end
end

-- API

function PABR_GetTeamSize(teamId) -- return size
	return #team[teamId]
end

function PABR_GetTeamMember(teamId, index) -- return guid, name
	return strsplit("/", team[teamId][index])
end

function PABR_GetTeamIndex(teamId, guid) -- return index or nil
	return lookup[teamId][guid]
end

function PABR_ResolveGUID(guid) -- return guid (does nothing if the unit is not a pet/summon)
	local current = guid
	while summon[current] do current = summon[current] end
	return current
end

function PABR_WipeEnemyTeam()
	wipe(team[2])
	wipe(lookup[2])
end

function PABR_WipeSummon()
	wipe(summon)
end

-- Handlers

function PABR_UpdatePlayerTeam()
	wipe(team[1])
	wipe(lookup[1])

	if IsInRaid() then
		for i=1, GetNumGroupMembers() do
			insertInTeam(team[1], lookup[1], "raid"..i)
		end
	else
		for i=1, GetNumGroupMembers() do
			insertInTeam(team[1], lookup[1], "party"..i)
		end
		insertInTeam(team[1], lookup[1], "player")
	end

	PABR_InspectLocalPlayer()

	PABR_EnqueueInspect()

	PABR_CheckRecompute()
end

function PABR_CheckEnemyUnit(unit)
	if UnitIsPlayer(unit) then
		if UnitIsEnemy("player", unit) then
			insertInTeam(team[2], lookup[2], unit)
		else
			clearFromTeam(team[2], lookup[2], unit)
		end
	end

	PABR_CheckRecompute()
end

function PABR_NotifySummon(sourceGUID, destGUID)
	summon[destGUID] = sourceGUID
end

function PABR_CheckPets()
	local now = GetTime()
	if now > NEXT_PET_CHECK then
		NEXT_PET_CHECK = now + 1
		
		for i=1, GetNumGroupMembers() do
			insertPet("raidpet"..i, "raid"..i)
		end

		for i=1, 5 do -- TODO: named constant for this?
			insertPet("arenapet"..i, "arena"..i)
		end
	end
end