PABR_Insert("DRUID", {
	[108288] = { -- Heart of the Wild
		detect = "cast",
		effect = {108291, 108292, 108293, 108294},
		cooldown = 360,
		tags = {"important", "attack"},
	},
	[108291] = { redirect = 108288 },
	[108292] = { redirect = 108288 },
	[108293] = { redirect = 108288 },
	[108294] = { redirect = 108288 },

	[106731] = { -- Incarnation
		detect = "cast",
		effect = {33891, 102543, 102558, 102560},
		cooldown = 180,
		tags = {"important", "attack"},
	},
	[33891]  = { redirect = 106731 },
	[102543] = { redirect = 106731 },
	[102558] = { redirect = 106731 },
	[102560] = { redirect = 106731 },

	[102401] = { -- Wild Charge
		detect = "cast",
		cooldown = 15,
		tags = {"utility"},
	},
	--[132302] = { redirect = 102401 }, -- TODO: check
	[16979] = { redirect = 102401 },
	[49376] = { redirect = 102401 },
	[102383] = { redirect = 102401 },
	[102416] = { redirect = 102401 },
	[102417] = { redirect = 102401 },

	[102280] = { -- Displacer Beast
		detect = "cast",
		effect = 0, -- TODO
		cooldown = 30,
		tags = {"important", "utility"},
	},

	[108238] = { -- Renewal
		detect = "cast",
		cooldown = 120,
		tags = {"important", "defense"},
	},
	
	[132158] = { -- Nature's Swiftness
		detect = "effectdown",
		cooldown = 60,
		tags = {"important", "defense"},
	},

	[102351] = { -- Cenarion Ward
		detect = "cast",
		effect = 0, -- TODO
		cooldown = 30,
		tags = {"defense"},
	},

	[132469] = { -- Typhoon
		detect = "cast",
		effect = 61391,
		cooldown = 30,
		tags = {"utility"},
	},
	[61391] = { redirect = 132469 },

	[102359] = { -- Mass Entanglement
		detect = "cast",
		effect = 102359,
		cooldown = 30,
		tags = {"control"},
	},

	[106737] = { -- Force of Nature
		detect = "cast",
		charges = 3,
		cooldown = 20,
		tags = {"important", "attack"},
	},
	-- TODO: check it works regardless of spec

	[102793] = { -- Ursol Vortex
		detect = "cast",
		cooldown = 60,
		tags = {"utility"},
	},

	[5211] = { -- Mighty Bash
		detect = "cast",
		effect = 5211,
		cooldown = 50,
		tags = {"important", "stun"},
	},

	[99] = { -- Disorienting Roar
		detect = "cast",
		effect = 99,
		cooldown = 30,
		tags = {"control"},
	},

	[124974] = { -- Nature's Vigil
		detect = "cast",
		effect = 124974,
		cooldown = 90,
		tags = {"important", "attack"},
	},

	[112071] = { -- Celestial Alignment
		detect = "cast",
		effect = 112071,
		cooldown = 180,
		tags = {"important", "attack"},
	},
	
	[106951] = { -- Berserk
		detect = "cast",
		effect = {50334, 106951},
		cooldown = 180,
		tags = {"important", "attack"},
	},
	[50334]  = { redirect = 106951 },

	[78675] = { -- Solar Beam
		detect = "cast",
		cooldown = 60,
		tags = {"important", "disable"},
	},
	
	[102795] = { -- Bear Hug
		detect = "cast",
		cooldown = 60,
		tags = {"stun"},
	},

	[5217] = { -- Tiger's Fury
		detect = "cast",
		cooldown = 30,
		tags = {"attack"},
	},
	
	[61336] = { -- Survival Instincts
		detect = "cast",
		cooldown = function(self) if self:HasGlyph(114223) then return 120 else return 180 end end,
		tags = {"important", "defense"},
	},

	[106839] = { -- Skull Bash
		detect = "cast",
		cooldown = function(self) if self:HasGlyph(116216) then return 25 else return 15 end end,
		interrupt = function(self) if self:HasGlyph(116216) then return 8 else return 4 end end,
		tags = {"important", "interrupt"},
		-- TODO: check
	},

	[102342] = { -- Ironbark
		detect = "cast",
		cooldown = function(self) if self:HasItemSet(4, 91173, 91175, 91177, 91179, 91181) then return 30 else return 60 end end, -- TODO: duplicate set versions
		tags = {"defense"},
	},

	[106898] = { -- Stampeding Roar
		detect = "cast",
		effect = {106898, 77764, 77761},
		cooldown = 120,
		tags = {"utility"},
	},
	[77764] = { redirect = 106898 },
	[77761] = { redirect = 106898 },

	[22570] = { -- Maim
		detect = "cast",
		effect = 22570,
		cooldown = 10,
		tags = {"stun"},
	},

	[33786] = { -- Cyclone
		detect = "cast",
		effect = 33786,
		cooldown = function(self) if self:HasSpec(103) then return 20 else return 0 end end,
		tags = {"control"},
	},
	
	[740] = { -- Tranquility
		detect = "cast",
		effect = 44203,
		cooldown = function(self) if self:HasSpec(105) then return 180 else return 480 end end,
		tags = {"important", "defense"},
	},

	[106922] = { -- Might of Ursoc
		detect = "cast",
		cooldown = function(self)
			local cd = 180
			if self:HasItemSet(2, 85379, 85380, 85381, 85382, 85383) then cd = cd - 60 end
			if self:HasGlyph(116238) then cd = cd + 120 end
			return cd
		end,
		tags = {"important", "defense"},
	},
	
	[22812] = { -- Barkskin
		detect = "cast",
		effect = 22812,
		cooldown = function(self) if self:HasSpec(105) then return 45 else return 60 end end,
		tags = {"defense"},
	},

	[1850] = { -- Dash
		detect = "cast",
		effect = 1850,
		cooldown = function(self) if self:HasGlyph(59219) then return 120 else return 180 end end,
		tags = {"utility"},
	},

	[20484] = { -- Rebirth
		detect = "cast",
		cooldown = 600,
		tags = {"resurrect"},
	},
	
	[29166] = { -- Innervate
		detect = "cast",
		effect = 29166,
		cooldown = 180,
		tags = {"utility"},
	},
	
	[16689] = { -- Nature's Grasp
		detect = "cast",
		effect = 16689,
		cooldown = function(self) if self:HasGlyph(116203) then return 30 else return 60 end end,
		tags = {"control"},
	},
} )